/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_RESPOSINSPEC                                             */
/* Tabela : RESPOSINSPEC                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_RESPOSINSPEC' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_RESPOSINSPEC
GO

CREATE TRIGGER DTULTATU_RESPOSINSPEC
ON RESPOSINSPEC
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'RESPOSINSPEC', null, 'CDINSPECAO='  + CDINSPECAO  + ';'+
                                           'CDRESPINSPEC='+ CDRESPINSPEC+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE RESPOSINSPEC
      SET DTULTATURINS = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(RESPOSINSPEC.CDRESPINSPEC,0) = ISNULL(INSERTED.CDRESPINSPEC,0)) AND
            (ISNULL(RESPOSINSPEC.CDINSPECAO,0)   = ISNULL(INSERTED.CDINSPECAO,0));

   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_RESPOSINSPEC','4.10.080';
GO

